Index: /stable/HeuristicLab.Analysis.Views/3.3/DataTableView.cs
===================================================================
--- /stable/HeuristicLab.Analysis.Views/3.3/DataTableView.cs	(revision 15096)
+++ /stable/HeuristicLab.Analysis.Views/3.3/DataTableView.cs	(revision 15097)
@@ -20,7 +20,4 @@
 #endregion
 
-using HeuristicLab.Collections;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
 using System;
 using System.Collections.Generic;
@@ -29,4 +26,7 @@
 using System.Windows.Forms;
 using System.Windows.Forms.DataVisualization.Charting;
+using HeuristicLab.Collections;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
 
 namespace HeuristicLab.Analysis.Views {
@@ -36,8 +36,19 @@
     protected List<Series> invisibleSeries;
     protected Dictionary<IObservableList<double>, DataRow> valuesRowsTable;
+    protected bool showChartOnly = false;
 
     public new DataTable Content {
       get { return (DataTable)base.Content; }
       set { base.Content = value; }
+    }
+
+    public bool ShowChartOnly {
+      get { return showChartOnly; }
+      set {
+        if (showChartOnly != value) {
+          showChartOnly = value;
+          UpdateControlsVisibility();
+        }
+      }
     }
 
@@ -48,4 +59,5 @@
       chart.CustomizeAllChartAreas();
       chart.ChartAreas[0].CursorX.Interval = 1;
+      chart.ContextMenuStrip.Items.Add(configureToolStripMenuItem);
     }
 
@@ -59,8 +71,6 @@
       Content.Rows.ItemsReplaced -= new CollectionItemsChangedEventHandler<DataRow>(Rows_ItemsReplaced);
       Content.Rows.CollectionReset -= new CollectionItemsChangedEventHandler<DataRow>(Rows_CollectionReset);
-      base.DeregisterContentEvents();
     }
     protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
       Content.VisualPropertiesChanged += new EventHandler(Content_VisualPropertiesChanged);
       Content.Rows.ItemsAdded += new CollectionItemsChangedEventHandler<DataRow>(Rows_ItemsAdded);
@@ -102,4 +112,5 @@
       if (Content != null) {
         chart.Titles[0].Text = Content.Name;
+        chart.Titles[0].Visible = !string.IsNullOrEmpty(Content.Name);
         AddDataRows(Content.Rows);
         ConfigureChartArea(chart.ChartAreas[0]);
@@ -120,8 +131,23 @@
       } else MessageBox.Show("Nothing to configure.");
     }
+
+    protected void UpdateControlsVisibility() {
+      if (InvokeRequired)
+        Invoke(new Action(UpdateControlsVisibility));
+      else {
+        foreach (Control c in Controls) {
+          if (c == chart) continue;
+          c.Visible = !showChartOnly;
+        }
+        chart.Dock = showChartOnly ? DockStyle.Fill : DockStyle.None;
+      }
+    }
+
     protected virtual void AddDataRows(IEnumerable<DataRow> rows) {
       foreach (var row in rows) {
         RegisterDataRowEvents(row);
-        var series = new Series(row.Name);
+        var series = new Series(row.Name) {
+          Tag = row
+        };
         if (row.VisualProperties.DisplayName.Trim() != String.Empty) series.LegendText = row.VisualProperties.DisplayName;
         else series.LegendText = row.Name;
@@ -133,4 +159,5 @@
       RecalculateAxesScale(chart.ChartAreas[0]);
       UpdateYCursorInterval();
+      UpdateHistogramTransparency();
     }
 
@@ -179,5 +206,8 @@
           break;
         case DataRowVisualProperties.DataRowChartType.Histogram:
-          series.ChartType = SeriesChartType.Column;
+          bool stacked = Content.VisualProperties.HistogramAggregation == DataTableVisualProperties.DataTableHistogramAggregation.Stacked;
+          series.ChartType = stacked ? SeriesChartType.StackedColumn : SeriesChartType.Column;
+          bool sideBySide = Content.VisualProperties.HistogramAggregation == DataTableVisualProperties.DataTableHistogramAggregation.SideBySide;
+          series.SetCustomProperty("DrawSideBySide", sideBySide ? "True" : "False");
           series.SetCustomProperty("PointWidth", "1");
           if (!series.Color.IsEmpty && series.Color.GetBrightness() < 0.25)
@@ -215,4 +245,5 @@
       if (!Content.VisualProperties.TitleColor.IsEmpty) chart.Titles[0].ForeColor = Content.VisualProperties.TitleColor;
       chart.Titles[0].Text = Content.VisualProperties.Title;
+      chart.Titles[0].Visible = !string.IsNullOrEmpty(Content.VisualProperties.Title);
 
       if (Content.VisualProperties.AxisTitleFont != null) area.AxisX.TitleFont = Content.VisualProperties.AxisTitleFont;
@@ -279,4 +310,27 @@
     }
 
+    protected void UpdateHistogramTransparency() {
+      if (Content.Rows.Any(r => RequiresTransparency(r) && r.VisualProperties.Color.IsEmpty)) {
+        foreach (var series in chart.Series) // sync colors before applying palette colors
+          series.Color = ((DataRow)series.Tag).VisualProperties.Color;
+        chart.ApplyPaletteColors();
+      }
+
+      var numTransparent = Content.Rows.Count(RequiresTransparency);
+      if (numTransparent <= 1) return;
+      foreach (var series in chart.Series) {
+        var row = (DataRow)series.Tag;
+        if (!RequiresTransparency(row))
+          continue;
+        var baseColor = row.VisualProperties.Color;
+        if (baseColor.IsEmpty) baseColor = series.Color;
+        series.Color = Color.FromArgb(180, baseColor);
+      }
+    }
+    private bool RequiresTransparency(DataRow row) {
+      return row.VisualProperties.ChartType == DataRowVisualProperties.DataRowChartType.Histogram
+             && Content.VisualProperties.HistogramAggregation == DataTableVisualProperties.DataTableHistogramAggregation.Overlapping;
+    }
+
     #region Event Handlers
     #region Content Event Handlers
@@ -285,5 +339,5 @@
         Invoke(new EventHandler(Content_NameChanged), sender, e);
       else {
-        chart.Titles[0].Text = Content.Name;
+        Content.VisualProperties.Title = Content.Name;
         base.Content_NameChanged(sender, e);
       }
@@ -295,4 +349,9 @@
         ConfigureChartArea(chart.ChartAreas[0]);
         RecalculateAxesScale(chart.ChartAreas[0]); // axes min/max could have changed
+
+        chart.Update(); // side-by-side and stacked histograms are not always correctly displayed without an update
+        // (chart update is required before the series are updated, otherwise the widths of the bars are updated incorrectly)
+        foreach (var row in Content.Rows.Where(r => r.VisualProperties.ChartType == DataRowVisualProperties.DataRowChartType.Histogram))
+          Row_VisualPropertiesChanged(row, EventArgs.Empty); // Histogram properties could have changed
       }
     }
@@ -339,6 +398,9 @@
         series.Points.Clear();
         ConfigureSeries(series, row);
-        FillSeriesWithRowValues(series, row);
-        RecalculateAxesScale(chart.ChartAreas[0]);
+        if (!invisibleSeries.Contains(series)) {
+          FillSeriesWithRowValues(series, row);
+          RecalculateAxesScale(chart.ChartAreas[0]);
+          UpdateHistogramTransparency();
+        }
       }
     }
@@ -451,4 +513,7 @@
     }
     #endregion
+    private void configureToolStripMenuItem_Click(object sender, EventArgs e) {
+      ShowConfiguration();
+    }
     #endregion
 
@@ -502,5 +567,18 @@
       switch (row.VisualProperties.ChartType) {
         case DataRowVisualProperties.DataRowChartType.Histogram:
-          CalculateHistogram(series, row);
+          // when a single histogram is updated, all histograms must be updated. otherwise the value ranges may not be equal.
+          var histograms = Content.Rows
+            .Where(r => r.VisualProperties.ChartType == DataRowVisualProperties.DataRowChartType.Histogram)
+            .ToList();
+          CalculateHistogram(series, row, histograms);
+          foreach (var h in from r in histograms
+                            where r != row
+                            let s = chart.Series.FindByName(r.Name)
+                            where s != null
+                            where !invisibleSeries.Contains(s)
+                            select new { row = r, series = s }) {
+            h.series.Points.Clear();
+            CalculateHistogram(h.series, h.row, histograms);
+          }
           break;
         default: {
@@ -526,12 +604,15 @@
     }
 
-    protected virtual void CalculateHistogram(Series series, DataRow row) {
+    protected virtual void CalculateHistogram(Series series, DataRow row, IEnumerable<DataRow> histogramRows) {
       series.Points.Clear();
       if (!row.Values.Any()) return;
-      int bins = row.VisualProperties.Bins;
-
-      double minValue = row.Values.Min();
-      double maxValue = row.Values.Max();
-      double intervalWidth = (maxValue - minValue) / bins;
+
+      var validValues = histogramRows.SelectMany(r => r.Values).Where(x => !IsInvalidValue(x)).ToList();
+      if (!validValues.Any()) return;
+
+      int bins = Content.VisualProperties.HistogramBins;
+      decimal minValue = (decimal)validValues.Min();
+      decimal maxValue = (decimal)validValues.Max();
+      decimal intervalWidth = (maxValue - minValue) / bins;
       if (intervalWidth < 0) return;
       if (intervalWidth == 0) {
@@ -540,21 +621,21 @@
       }
 
-      if (!row.VisualProperties.ExactBins) {
-        intervalWidth = HumanRoundRange(intervalWidth);
+      if (!Content.VisualProperties.HistogramExactBins) {
+        intervalWidth = (decimal)HumanRoundRange((double)intervalWidth);
         minValue = Math.Floor(minValue / intervalWidth) * intervalWidth;
         maxValue = Math.Ceiling(maxValue / intervalWidth) * intervalWidth;
       }
 
-      double intervalCenter = intervalWidth / 2;
-
-      double min = 0.0, max = 0.0;
+      decimal intervalCenter = intervalWidth / 2;
+
+      decimal min = 0.0m, max = 0.0m;
       if (!Double.IsNaN(Content.VisualProperties.XAxisMinimumFixedValue) && !Content.VisualProperties.XAxisMinimumAuto)
-        min = Content.VisualProperties.XAxisMinimumFixedValue;
+        min = (decimal)Content.VisualProperties.XAxisMinimumFixedValue;
       else min = minValue;
       if (!Double.IsNaN(Content.VisualProperties.XAxisMaximumFixedValue) && !Content.VisualProperties.XAxisMaximumAuto)
-        max = Content.VisualProperties.XAxisMaximumFixedValue;
+        max = (decimal)Content.VisualProperties.XAxisMaximumFixedValue;
       else max = maxValue + intervalWidth;
 
-      double axisInterval = intervalWidth / row.VisualProperties.ScaleFactor;
+      double axisInterval = (double)intervalWidth / row.VisualProperties.ScaleFactor;
 
       var area = chart.ChartAreas[0];
@@ -564,5 +645,5 @@
 
       // get the range or intervals which define the grouping of the frequency values
-      var doubleRange = DoubleRange(min, max, intervalWidth).Skip(1).ToList();
+      var range = Range(min, max, intervalWidth).Skip(1).ToList();
 
       // aggregate the row values by unique key and frequency value
@@ -573,14 +654,15 @@
                               select new Tuple<double, double>(g.First(), g.Count())).ToList();
 
-      // shift the chart to the left so the bars are placed on the intervals
-      if (valueFrequencies.First().Item1 < doubleRange.First())
-        series.Points.Add(new DataPoint(min - intervalWidth, 0));
+      // ensure that each column is displayed completely on the chart by adding two dummy datapoints on the upper and lower range
+      series.Points.Add(new DataPoint((double)(min - intervalWidth), 0));
+      series.Points.Add(new DataPoint((double)(max + intervalWidth), 0));
 
       // add data points
       int j = 0;
-      foreach (var d in doubleRange) {
+      int overallCount = row.Values.Count(x => !IsInvalidValue(x));
+      foreach (var d in range) {
         double sum = 0.0;
         // sum the frequency values that fall within the same interval
-        while (j < valueFrequencies.Count && valueFrequencies[j].Item1 < d) {
+        while (j < valueFrequencies.Count && (decimal)valueFrequencies[j].Item1 < d) {
           sum += valueFrequencies[j].Item2;
           ++j;
@@ -592,8 +674,8 @@
                               ? "Y"
                               : Content.VisualProperties.YAxisTitle;
-        series.Points.Add(new DataPoint(d - intervalCenter, sum) {
+        series.Points.Add(new DataPoint((double)(d - intervalCenter), sum) {
           ToolTip =
-            xAxisTitle + ": [" + (d - intervalWidth) + "-" + d + ")" + Environment.NewLine +
-            yAxisTitle + ": " + sum
+            string.Format("{0}: [{1} - {2})", xAxisTitle, (d - intervalWidth), d) + Environment.NewLine +
+            string.Format("{0}: {1} ({2:F2}%)", yAxisTitle, sum, sum / overallCount * 100)
         });
       }
@@ -601,6 +683,6 @@
 
     #region Helpers
-    public static IEnumerable<double> DoubleRange(double min, double max, double step) {
-      double i;
+    public static IEnumerable<decimal> Range(decimal min, decimal max, decimal step) {
+      decimal i;
       for (i = min; i <= max; i += step)
         yield return i;
Index: /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesControl.Designer.cs
===================================================================
--- /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesControl.Designer.cs	(revision 15096)
+++ /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesControl.Designer.cs	(revision 15097)
@@ -105,4 +105,12 @@
       this.label7 = new System.Windows.Forms.Label();
       this.label8 = new System.Windows.Forms.Label();
+      this.histogramTabPage = new System.Windows.Forms.TabPage();
+      this.histogramGroupBox = new System.Windows.Forms.GroupBox();
+      this.histogramBinsExactRadioButton = new System.Windows.Forms.RadioButton();
+      this.histogramBinsApproximatelyRadioButton = new System.Windows.Forms.RadioButton();
+      this.histogramBinsNumericUpDown = new System.Windows.Forms.NumericUpDown();
+      this.label16 = new System.Windows.Forms.Label();
+      this.label17 = new System.Windows.Forms.Label();
+      this.histogramAggregationComboBox = new System.Windows.Forms.ComboBox();
       this.titleTextBox = new System.Windows.Forms.TextBox();
       this.label15 = new System.Windows.Forms.Label();
@@ -131,4 +139,7 @@
       this.panel6.SuspendLayout();
       this.panel5.SuspendLayout();
+      this.histogramTabPage.SuspendLayout();
+      this.histogramGroupBox.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.histogramBinsNumericUpDown)).BeginInit();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
@@ -489,4 +500,5 @@
       this.axisTabControl.Controls.Add(this.xAxisTabPage);
       this.axisTabControl.Controls.Add(this.yAxisTabPage);
+      this.axisTabControl.Controls.Add(this.histogramTabPage);
       this.axisTabControl.Location = new System.Drawing.Point(0, 84);
       this.axisTabControl.Name = "axisTabControl";
@@ -791,4 +803,107 @@
       this.label8.TabIndex = 2;
       this.label8.Text = "&Minimum:";
+      // 
+      // histogramTabPage
+      // 
+      this.histogramTabPage.Controls.Add(this.histogramGroupBox);
+      this.histogramTabPage.Location = new System.Drawing.Point(4, 22);
+      this.histogramTabPage.Name = "histogramTabPage";
+      this.histogramTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.histogramTabPage.Size = new System.Drawing.Size(447, 263);
+      this.histogramTabPage.TabIndex = 2;
+      this.histogramTabPage.Text = "Histogram";
+      this.histogramTabPage.UseVisualStyleBackColor = true;
+      // 
+      // histogramGroupBox
+      // 
+      this.histogramGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.histogramGroupBox.Controls.Add(this.histogramBinsExactRadioButton);
+      this.histogramGroupBox.Controls.Add(this.histogramBinsApproximatelyRadioButton);
+      this.histogramGroupBox.Controls.Add(this.histogramBinsNumericUpDown);
+      this.histogramGroupBox.Controls.Add(this.label16);
+      this.histogramGroupBox.Controls.Add(this.label17);
+      this.histogramGroupBox.Controls.Add(this.histogramAggregationComboBox);
+      this.histogramGroupBox.Location = new System.Drawing.Point(3, 3);
+      this.histogramGroupBox.Name = "histogramGroupBox";
+      this.histogramGroupBox.Size = new System.Drawing.Size(441, 75);
+      this.histogramGroupBox.TabIndex = 2;
+      this.histogramGroupBox.TabStop = false;
+      this.histogramGroupBox.Text = "Histogram Properties";
+      // 
+      // histogramBinsExactRadioButton
+      // 
+      this.histogramBinsExactRadioButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.histogramBinsExactRadioButton.AutoSize = true;
+      this.histogramBinsExactRadioButton.Location = new System.Drawing.Point(383, 19);
+      this.histogramBinsExactRadioButton.Name = "histogramBinsExactRadioButton";
+      this.histogramBinsExactRadioButton.Size = new System.Drawing.Size(52, 17);
+      this.histogramBinsExactRadioButton.TabIndex = 3;
+      this.histogramBinsExactRadioButton.TabStop = true;
+      this.histogramBinsExactRadioButton.Text = "&Exact";
+      this.histogramBinsExactRadioButton.UseVisualStyleBackColor = true;
+      this.histogramBinsExactRadioButton.CheckedChanged += new System.EventHandler(this.histogramBinsExactRadioButton_CheckedChanged);
+      // 
+      // histogramBinsApproximatelyRadioButton
+      // 
+      this.histogramBinsApproximatelyRadioButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.histogramBinsApproximatelyRadioButton.AutoSize = true;
+      this.histogramBinsApproximatelyRadioButton.Location = new System.Drawing.Point(287, 19);
+      this.histogramBinsApproximatelyRadioButton.Name = "histogramBinsApproximatelyRadioButton";
+      this.histogramBinsApproximatelyRadioButton.Size = new System.Drawing.Size(90, 17);
+      this.histogramBinsApproximatelyRadioButton.TabIndex = 2;
+      this.histogramBinsApproximatelyRadioButton.TabStop = true;
+      this.histogramBinsApproximatelyRadioButton.Text = "&Approximately";
+      this.histogramBinsApproximatelyRadioButton.UseVisualStyleBackColor = true;
+      // 
+      // histogramBinsNumericUpDown
+      // 
+      this.histogramBinsNumericUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.histogramBinsNumericUpDown.Location = new System.Drawing.Point(82, 19);
+      this.histogramBinsNumericUpDown.Minimum = new decimal(new int[] {
+            1,
+            0,
+            0,
+            0});
+      this.histogramBinsNumericUpDown.Name = "histogramBinsNumericUpDown";
+      this.histogramBinsNumericUpDown.Size = new System.Drawing.Size(186, 20);
+      this.histogramBinsNumericUpDown.TabIndex = 1;
+      this.histogramBinsNumericUpDown.Value = new decimal(new int[] {
+            1,
+            0,
+            0,
+            0});
+      this.histogramBinsNumericUpDown.ValueChanged += new System.EventHandler(this.histogramBinsNumericUpDown_ValueChanged);
+      // 
+      // label16
+      // 
+      this.label16.AutoSize = true;
+      this.label16.Location = new System.Drawing.Point(6, 49);
+      this.label16.Name = "label16";
+      this.label16.Size = new System.Drawing.Size(67, 13);
+      this.label16.TabIndex = 0;
+      this.label16.Text = "Aggregation:";
+      // 
+      // label17
+      // 
+      this.label17.AutoSize = true;
+      this.label17.Location = new System.Drawing.Point(6, 21);
+      this.label17.Name = "label17";
+      this.label17.Size = new System.Drawing.Size(30, 13);
+      this.label17.TabIndex = 0;
+      this.label17.Text = "&Bins:";
+      // 
+      // histogramAggregationComboBox
+      // 
+      this.histogramAggregationComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.histogramAggregationComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.histogramAggregationComboBox.FormattingEnabled = true;
+      this.histogramAggregationComboBox.Location = new System.Drawing.Point(82, 45);
+      this.histogramAggregationComboBox.Name = "histogramAggregationComboBox";
+      this.histogramAggregationComboBox.Size = new System.Drawing.Size(353, 21);
+      this.histogramAggregationComboBox.TabIndex = 3;
+      this.histogramAggregationComboBox.SelectedValueChanged += new System.EventHandler(this.histogramAggregationComboBox_SelectedValueChanged);
       // 
       // titleTextBox
@@ -927,4 +1042,8 @@
       this.panel5.ResumeLayout(false);
       this.panel5.PerformLayout();
+      this.histogramTabPage.ResumeLayout(false);
+      this.histogramGroupBox.ResumeLayout(false);
+      this.histogramGroupBox.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.histogramBinsNumericUpDown)).EndInit();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.ResumeLayout(false);
@@ -1005,4 +1124,12 @@
     private System.Windows.Forms.CheckBox yAxisSecondaryLogScaleCheckBox;
     private System.Windows.Forms.CheckBox yAxisPrimaryLogScaleCheckBox;
+    private System.Windows.Forms.TabPage histogramTabPage;
+    private System.Windows.Forms.GroupBox histogramGroupBox;
+    private System.Windows.Forms.RadioButton histogramBinsExactRadioButton;
+    private System.Windows.Forms.RadioButton histogramBinsApproximatelyRadioButton;
+    private System.Windows.Forms.NumericUpDown histogramBinsNumericUpDown;
+    private System.Windows.Forms.Label label16;
+    private System.Windows.Forms.Label label17;
+    private System.Windows.Forms.ComboBox histogramAggregationComboBox;
   }
 }
Index: /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesControl.cs
===================================================================
--- /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesControl.cs	(revision 15096)
+++ /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesControl.cs	(revision 15097)
@@ -20,8 +20,9 @@
 #endregion
 
+using System;
+using System.Drawing;
+using System.Windows.Forms;
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
-using System.Drawing;
-using System.Windows.Forms;
 
 namespace HeuristicLab.Analysis.Views {
@@ -58,4 +59,5 @@
       errorProvider.SetIconPadding(yAxisSecondaryMinimumFixedTextBox, 2);
       errorProvider.SetIconPadding(yAxisSecondaryMaximumFixedTextBox, 2);
+      histogramAggregationComboBox.DataSource = Enum.GetValues(typeof(DataTableVisualProperties.DataTableHistogramAggregation));
     }
 
@@ -101,4 +103,9 @@
           yAxisSecondaryMaximumFixedTextBox.Text = string.Empty;
           yAxisSecondaryLogScaleCheckBox.Checked = false;
+
+          histogramBinsNumericUpDown.Value = 1;
+          histogramBinsApproximatelyRadioButton.Checked = false;
+          histogramBinsExactRadioButton.Checked = false;
+          histogramAggregationComboBox.SelectedIndex = -1;
         } else {
           titleFontLabel.Text = "( " + FormatFont(Content.TitleFont) + " )";
@@ -139,4 +146,13 @@
           yAxisSecondaryMaximumFixedTextBox.Text = Content.SecondYAxisMaximumFixedValue.ToString();
           yAxisSecondaryLogScaleCheckBox.Checked = Content.SecondYAxisLogScale;
+
+          if (Content.HistogramBins < histogramBinsNumericUpDown.Minimum)
+            histogramBinsNumericUpDown.Value = histogramBinsNumericUpDown.Minimum;
+          else if (Content.HistogramBins > histogramBinsNumericUpDown.Maximum)
+            histogramBinsNumericUpDown.Value = histogramBinsNumericUpDown.Maximum;
+          else histogramBinsNumericUpDown.Value = Content.HistogramBins;
+          histogramBinsApproximatelyRadioButton.Checked = !Content.HistogramExactBins;
+          histogramBinsExactRadioButton.Checked = Content.HistogramExactBins;
+          histogramAggregationComboBox.SelectedItem = Content.HistogramAggregation;
         }
       } finally { SuppressEvents = false; }
@@ -483,4 +499,28 @@
       }
     }
+
+    private void histogramBinsNumericUpDown_ValueChanged(object sender, System.EventArgs e) {
+      if (!SuppressEvents && Content != null) {
+        Content.HistogramBins = (int)histogramBinsNumericUpDown.Value;
+      }
+    }
+
+    private void histogramBinsExactRadioButton_CheckedChanged(object sender, System.EventArgs e) {
+      if (!SuppressEvents && Content != null) {
+        SuppressEvents = true;
+        try {
+          Content.HistogramExactBins = histogramBinsExactRadioButton.Checked;
+        } finally { SuppressEvents = false; }
+      }
+    }
+
+    private void histogramAggregationComboBox_SelectedValueChanged(object sender, System.EventArgs e) {
+      if (!SuppressEvents && Content != null) {
+        SuppressEvents = true;
+        try {
+          Content.HistogramAggregation = (DataTableVisualProperties.DataTableHistogramAggregation)histogramAggregationComboBox.SelectedValue;
+        } finally { SuppressEvents = false; }
+      }
+    }
     #endregion
 
Index: /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesDialog.Designer.cs
===================================================================
--- /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesDialog.Designer.cs	(revision 15096)
+++ /stable/HeuristicLab.Analysis.Views/3.3/DataTableVisualPropertiesDialog.Designer.cs	(revision 15097)
@@ -69,5 +69,5 @@
       this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.okButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.okButton.Location = new System.Drawing.Point(325, 425);
+      this.okButton.Location = new System.Drawing.Point(325, 454);
       this.okButton.Name = "okButton";
       this.okButton.Size = new System.Drawing.Size(75, 23);
@@ -81,5 +81,5 @@
       this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
-      this.cancelButton.Location = new System.Drawing.Point(406, 425);
+      this.cancelButton.Location = new System.Drawing.Point(406, 454);
       this.cancelButton.Name = "cancelButton";
       this.cancelButton.Size = new System.Drawing.Size(75, 23);
@@ -99,5 +99,5 @@
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(469, 407);
+      this.tabControl.Size = new System.Drawing.Size(469, 436);
       this.tabControl.TabIndex = 2;
       // 
@@ -108,5 +108,5 @@
       this.seriesTabPage.Name = "seriesTabPage";
       this.seriesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.seriesTabPage.Size = new System.Drawing.Size(461, 381);
+      this.seriesTabPage.Size = new System.Drawing.Size(461, 410);
       this.seriesTabPage.TabIndex = 0;
       this.seriesTabPage.Text = "Series";
@@ -133,5 +133,5 @@
       this.splitContainer.Panel2.Controls.Add(this.dataRowVisualPropertiesControl);
       this.splitContainer.Panel2MinSize = 50;
-      this.splitContainer.Size = new System.Drawing.Size(461, 381);
+      this.splitContainer.Size = new System.Drawing.Size(461, 410);
       this.splitContainer.SplitterDistance = 125;
       this.splitContainer.TabIndex = 0;
@@ -169,5 +169,5 @@
       this.seriesListView.Name = "seriesListView";
       this.seriesListView.ShowGroups = false;
-      this.seriesListView.Size = new System.Drawing.Size(119, 346);
+      this.seriesListView.Size = new System.Drawing.Size(119, 375);
       this.seriesListView.TabIndex = 2;
       this.seriesListView.UseCompatibleStateImageBehavior = false;
@@ -183,5 +183,5 @@
       this.dataRowVisualPropertiesControl.Location = new System.Drawing.Point(3, 26);
       this.dataRowVisualPropertiesControl.Name = "dataRowVisualPropertiesControl";
-      this.dataRowVisualPropertiesControl.Size = new System.Drawing.Size(326, 352);
+      this.dataRowVisualPropertiesControl.Size = new System.Drawing.Size(326, 381);
       this.dataRowVisualPropertiesControl.TabIndex = 0;
       // 
@@ -213,5 +213,5 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.CancelButton = this.cancelButton;
-      this.ClientSize = new System.Drawing.Size(493, 460);
+      this.ClientSize = new System.Drawing.Size(493, 489);
       this.Controls.Add(this.tabControl);
       this.Controls.Add(this.cancelButton);
Index: /stable/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj	(revision 15096)
+++ /stable/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj	(revision 15097)
@@ -105,4 +105,8 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="ALGLIB-3.7.0, Version=3.7.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <HintPath>..\..\bin\ALGLIB-3.7.0.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -122,4 +126,16 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="DataTableView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="DataTableView.Designer.cs">
+      <DependentUpon>DataTableView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="ScatterPlotView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ScatterPlotView.Designer.cs">
+      <DependentUpon>ScatterPlotView.cs</DependentUpon>
+    </Compile>
     <Compile Include="ScatterPlotVisualPropertiesDialog.cs">
       <SubType>Form</SubType>
@@ -140,10 +156,4 @@
       <DependentUpon>ScatterPlotDataRowVisualPropertiesControl.cs</DependentUpon>
     </Compile>
-    <Compile Include="ScatterPlotView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ScatterPlotView.Designer.cs">
-      <DependentUpon>ScatterPlotView.cs</DependentUpon>
-    </Compile>
     <Compile Include="ScatterPlotHistoryView.cs">
       <SubType>UserControl</SubType>
@@ -209,10 +219,4 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="DataTableView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="DataTableView.Designer.cs">
-      <DependentUpon>DataTableView.cs</DependentUpon>
-    </Compile>
     <Compile Include="HistogramControl.cs">
       <SubType>UserControl</SubType>
Index: /stable/HeuristicLab.Analysis.Views/3.3/Plugin.cs.frame
===================================================================
--- /stable/HeuristicLab.Analysis.Views/3.3/Plugin.cs.frame	(revision 15096)
+++ /stable/HeuristicLab.Analysis.Views/3.3/Plugin.cs.frame	(revision 15097)
@@ -28,4 +28,5 @@
   [Plugin("HeuristicLab.Analysis.Views", "3.3.14.$WCREV$")]
   [PluginFile("HeuristicLab.Analysis.Views-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.ALGLIB", "3.7.0")]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
